#ifndef _Edge_h
#define _Edge_h

/****************************************************************
 *
 * Edge widget
 *
 ****************************************************************/

/* Resources:

 Name		     Class		RepType		Default Value
 ----		     -----		-------		-------------
 background	     Background		Pixel		XtDefaultBackground
 border		     BorderColor	Pixel		XtDefaultForeground
 borderWidth	     BorderWidth	Dimension	1
 destroyCallback     Callback		Pointer		NULL
 height		     Height		Dimension	0
 mappedWhenManaged   MappedWhenManaged	Boolean		True
 sensitive	     Sensitive		Boolean		True
 width		     Width		Dimension	0
 x		     Position		Position	0
 y		     Position		Position	0
 foreground          Foreground         Pixel           XtDefaultForeground
 orientation         Orientation        Orientation     NoEdge
 font                Font               XFontStruct*    XtDefaultFont

*/

/* define any special resource names here that are not in <X11/StringDefs.h> */

#define XtNorientation 	"orientation"
/* declare specific EdgeWidget class and instance datatypes */



typedef enum {
	NoEdge,
	Verticle,
	Horizontal
	} Orientation;

typedef struct _EdgeClassRec*	EdgeWidgetClass;
typedef struct _EdgeRec*	EdgeWidget;

/* declare the class constant */

extern WidgetClass edgeWidgetClass;

#endif  _Edge_h
