#ifndef _NodeP_h
#define _NodeP_h

#include "Node.h"
/* include superclass private header file */
#include <X11/Xaw/CoreP.h>

/* define unique representation types not found in <X11/StringDefs.h> */

#define XtRNodeResource		"NodeResource"

typedef struct {
    int empty;
    } NodeClassPart;

typedef struct _NodeClassRec {
    CoreClassPart	core_class;
    NodeClassPart	node_class;
    } NodeClassRec;

extern NodeClassRec nodeClassRec;


typedef enum {
    idle,
    scheduled,
    initiate,
    done
    } ProcState;


typedef struct {
    /* resources */
    Pixel foreground;
    XFontStruct* font;
    NodeType node_type;
    int initiate;
    int scheduled;
    int idle;
    int done;
    Pixel initiateColor;
    Pixel doneColor;
    Pixel scheduledColor;

    /* private state */
    ProcState processor[NUMPROC];
    Position name_x;		/* position to put name */
    Position name_y;
    Dimension name_height;	/* height of name font */
    Dimension name_width;	/* width of name string in pixel */
    Dimension name_len;		/* length of name (char) */
    Position first_row;		/* position to put processor 0 */
    Dimension proc_height;	/* hieght of each processor */
    Dimension proc_width;	/* width of each processor */
    Dimension initiate_height;
    Dimension scheduled_height;
    Dimension idle_height;
    Dimension done_height;
    int scale_factor;		/* scaling factor */  
    Boolean too_small;		/* True if widget is too small */
    XFontStruct* small_font;
    Dimension number_height;
    GC small_gc;		/* for the numbers */
    GC gc;
    GC initiateGC;
    GC doneGC;
    GC scheduledGC;
    } NodePart;

typedef struct _NodeRec {
    CorePart	core;
    NodePart	node;
    } NodeRec;

#endif  _NodeP_h
