#ifndef GPKT_H
#define GPKT_H

#define X_Port 4001			/* wellknown port of xgamma */

#define GMAGIC 0x3f18			/* Magic number for each packet */

#define GGSELECT	1		/* Select op */
#define GGJOIN		2		/* Join op  */
#define GGSTORE		3		/* Store op */
#define GGSPOOL		4		/* Spool op */


#define GGSTART		20		/* Processor started */
#define GGOP_DONE	21		/* Processor done */
#define GGHT_DONE	22		/* Processor scheduled */

#define GGTREE		99		/* tree follows header */
#define GGUPD		100		/* update info follows header */
#define GGEND		101		/* ready to close connection */


typedef struct {
    u_short magic;	/* magic number */
    u_short nodecnt;	/* Number of nodes if GGTREE */
    u_short type;	/* GGTREE or GGUPD */
    u_short patch;
    } GPKT_HDR;

typedef struct {
    u_long op;
    u_char bmap[4];
    } GPKT_NODE;

typedef struct {
    u_char processor;
    u_char op;
    u_char stat;
    } GPKT_UPD;

#define GPKT_HDR_LEN 	8
#define GPKT_UPD_LEN 	3

extern void g_init();
extern void g_q2gpkt();
extern void g_update();
extern void g_close();
extern void print_update();
extern char* op_str();
extern char* status_str();


#endif GPKT_H
