#include <stdio.h>
#include <sys/types.h>
#include "gpkt.h"
    
    
static char *optable[] = {
	"SELECT",
	"JOIN",
	"STORE",
"SPOOL"
};

static char *statustable[] = {
    "INITIATED",
    "DONE",
    "HALF DONE"
    };

char* op_str(op)
int op;
{
    return optable[op-GGSELECT];
}


char* status_str(status)
int status;
{
    return statustable[status-GGSTART];
}


void print_update(p)
GPKT_UPD* p;
{
    printf("Got an update : ");
    printf("\n\tOperation : ");
    switch(p->op)   {
    case GGSELECT:
	printf("SELECT");
	break;
    case GGJOIN:
	printf("JOIN");
	break;
    case GGSTORE:
	printf("STORE");
	break;
    case GGSPOOL:
	printf("SPOOL");
	break;
    default:
	fprintf(stderr, "Unknown update\n");
	exit(1);
    }
    
    printf("\n\tProcessor : %d", p->processor);
    
    printf("\n\tStatus    : ");
    switch(p->stat)  {
    case GGSTART : 
	printf("START");
	break;
    case GGOP_DONE:
	printf("OP_DONE");
	break;
    case GGHT_DONE:
	printf("HT_DONE");
	break;
    default:
	fprintf(stderr, "Unknown update\n");
	exit(1);
    }
    printf("\n");
}
