#include <X11/StringDefs.h>
#include <X11/Intrinsic.h>
#include <X11/Xaw/Form.h>
#include <stdio.h>
#include <X11/Xaw/Label.h>
#include "xgamma.h"
#include "input.h"
#include "display.h"
    
Widget toplevel;

static XrmOptionDescRec opTable[] = {
    { "-initiate",	"*initiateColor",	XrmoptionSepArg, (caddr_t) NULL},
    { "-scheduled",	"*scheduledColor",	XrmoptionSepArg, (caddr_t) NULL},
    { "-done",	"*doneColor",		XrmoptionSepArg, (caddr_t) NULL},
};

main(argc, argv)
int argc;
char** argv;
{
    XtAppContext context;
    Widget toplabel;
    Arg arg;
    toplevel = XtInitialize("xgamma", "Demo", opTable, XtNumber(opTable), 
			    &argc, argv);
    
    if (argc != 1)  {
	fprintf(stderr, "Usage: xgamma\n");
	exit(1);
    }
    
    context = XtWidgetToApplicationContext(toplevel);
    input_init(context);
    
    toplabel = XtCreateManagedWidget("xgamma-label", labelWidgetClass,
				     toplevel, (Arg*) NULL, (int) 0);
    XtSetArg(arg, XtNlabel, " XGAMMA Database Machine ");
    XtSetValues(toplabel, &arg, 1);
    
    XtRealizeWidget(toplevel); 
    
    XtMainLoop();
}
