#ifndef _JoinP_h
#define _JoinP_h

#include "Join.h"
/* include superclass private header file */
#include <X11/Xaw/FormP.h>

/* define unique representation types not found in <X11/StringDefs.h> */

#define XtRJoinResource		"JoinResource"

typedef struct {
    int empty;
    } JoinClassPart;

typedef struct _JoinClassRec {
    CoreClassPart	core_class;
    CompositeClassPart	composite_class;
    ConstraintClassPart	constraint_class;
    FormClassPart	form_class;
    JoinClassPart	join_class;
    } JoinClassRec;

extern JoinClassRec joinClassRec;


typedef struct {
    /* resources */
    int empty;

    /* private state */
    Widget right_node;
    Widget top_edge;
    Widget middle_edge;
    Widget right_edge;
    Widget jb;
    Widget jp;
    } JoinPart;

typedef struct _JoinRec {
    CorePart		core;
    CompositePart	composite;
    ConstraintPart	constraint;
    FormPart		form;
    JoinPart	join;
    } JoinRec;


typedef struct { int empty; } JoinConstraintsPart;

typedef struct _DialogConstraintsRec {
    FormConstraintsPart	form;
    JoinConstraintsPart join;
    } JoinConstraintsRec, *JoinBuldConstraints;

#endif  _JoinP_h
