#include <stdio.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include "Node.h"

Widget toplevel;
Widget node;
XtAppContext context;

void change_state();

main(argc, argv)
int argc;
char** argv;
{
    Arg arg;
    int i;

    static Arg args[] = {
	{ XtNnodeType, (XtArgVal) JoinProbe },
	};


    toplevel = XtInitialize("main", "Demo", NULL, 0, &argc, argv);

    if (argc != 1)  {
	fprintf(stderr, "Usage: test\n");
	exit(1);
	}

    node = XtCreateManagedWidget("node", nodeWidgetClass, toplevel,
					args, XtNumber(args));

    context = XtWidgetToApplicationContext(node);
    for (i = 0; i < 32; i++)  {
	switch (i % 4)  {
	    case 0: arg.name = XtNinitiate;
		    break;
	    case 1: arg.name = XtNscheduled;
		    break;
	    case 2: arg.name = XtNdone;
		    break;
	    case 3: arg.name = XtNidle;
		    break;
	    }

	arg.value = (XtArgVal) i;
	XtSetValues(node, &arg, 1);
	}
		

    XtRealizeWidget(toplevel);

    for (i = 0; i < 32; i++)  {
       arg.name = XtNidle;
       arg.value = (XtArgVal) i;
       XtSetValues(node, &arg, 1);
       }

    for (i = 0; i < 32; i++)  {
       arg.name = XtNdone;
       arg.value = (XtArgVal) i;
       XtSetValues(node, &arg, 1);
       }
    
    XtMainLoop();
}



void change_state(data, id)
caddr_t data;
XtIntervalId* id;
{
    Arg arg[2];
    int processor;
    int action;

    printf("change_state() called\n");
    
    processor = random() % 16;
    action = rand()%3;

    switch (action)  {
	case 0: arg[0].name = XtNdone;
		arg[1].name = XtNscheduled;
		break;
	case 1:	arg[0].name = XtNscheduled;
		arg[1].name = XtNinitiate;
		break;
	case 2: arg[0].name = XtNinitiate;
		arg[1].name = XtNdone;
		break;
	case 3: arg[0].name = XtNidle;
		arg[1].name = XtNscheduled;
		break;
	}

    arg[0].value = (XtArgVal) processor;
    arg[1].name = arg[0].name;
    arg[1].value = 32-arg[0].value;

    XtSetValues(node, arg, 2);

    XtAppAddTimeOut(context, 500, change_state, NULL);
}
