#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>
#include "Node.h"
#include "Edge.h"
#include "SelectP.h"
#include <stdio.h>

#define offset(field) XtOffset(SelectWidget, field)


#undef offset


static void Initialize();

#define SuperClass   ((WidgetClass) &formClassRec)

SelectClassRec selectClassRec = {
  { /* core fields */
    /* superclass		*/	(WidgetClass) SuperClass,
    /* class_name		*/	"Select",
    /* widget_size		*/	sizeof(SelectRec),
    /* class_initialize		*/	NULL,
    /* class_part_initialize	*/	NULL,
    /* class_inited		*/	FALSE,
    /* initialize		*/	Initialize,
    /* initialize_hook		*/	NULL,
    /* realize			*/	XtInheritRealize,
    /* actions			*/	NULL,
    /* num_actions		*/	0,
    /* resources		*/	NULL,
    /* num_resources		*/	0,
    /* xrm_class		*/	NULLQUARK,
    /* compress_motion		*/	TRUE,
    /* compress_exposure	*/	TRUE,
    /* compress_enterleave	*/	TRUE,
    /* visible_interest		*/	FALSE,
    /* destroy			*/	NULL,
    /* resize			*/	XtInheritResize,
    /* expose			*/	XtInheritExpose,
    /* set_values		*/	NULL,
    /* set_values_hook		*/	NULL,
    /* set_values_almost	*/	XtInheritSetValuesAlmost,
    /* get_values_hook		*/	NULL,
    /* accept_focus		*/	NULL,
    /* version			*/	XtVersion,
    /* callback_private		*/	NULL,
    /* tm_table			*/	NULL,
    /* query_geometry		*/	XtInheritQueryGeometry,
    /* display_accelerator	*/	XtInheritDisplayAccelerator,
    /* extension		*/	NULL
  },
  {
    /* composite Class fields initialization */
    /* geometry_manager		*/	XtInheritGeometryManager,
    /* change_managed		*/	XtInheritChangeManaged,
    /* insert_child		*/	XtInheritInsertChild,
    /* delete_child		*/	XtInheritDeleteChild,
    /* extension		*/	NULL
  },
  { 
    /* constraint Class fields initialization */
    /* subresources		*/	NULL,
    /* subresource_count	*/	0,
    /* constraint_size		*/	sizeof(SelectConstraintsRec),
    /* initialize		*/	NULL,
    /* destroy			*/ 	NULL,
    /* set_values		*/	NULL,
    /* extension		*/	NULL
  },
  {
    /* form Class fields initialization */
    /* layout			*/	XtInheritLayout
  },
  { /* SelectClass fields initialization */
    /* empty			*/	0
  }
};

WidgetClass selectWidgetClass = (WidgetClass)&selectClassRec;


static void Initialize(request, new)
Widget request;
Widget new;
{
    Arg arg;
    SelectWidget sw = (SelectWidget) new;
    static Arg node_args[] = {
	{ XtNnodeType, (XtArgVal) Select },
	{ XtNhorizDistance, (XtArgVal) 10 },
	{ XtNfromVert, (XtArgVal) NULL },
	{ XtNvertDistance, (XtArgVal) 0},
	};
    static Arg template_edge_args[] = {
	{ XtNorientation, (XtArgVal) Verticle },
	{ XtNborderWidth, (XtArgVal) 0 },
	{ XtNfromHoriz, (XtArgVal) NULL },
	{ XtNhorizDistance, (XtArgVal) 10 },
	{ XtNwidth, (XtArgVal) 0 },
	{ XtNheight, (XtArgVal) 0 },
	{ XtNvertDistance, (XtArgVal) 0 },
	};
    int width, height;
    Arg edge_args[10];
    int i;


    Widget children[5], *childP = children;

    for (i = 0; i < 7; i++)  {
	edge_args[i].name = template_edge_args[i].name;
	edge_args[i].value = template_edge_args[i].value;
	}

    /*
     * Create edge joining select node and whatever on top
     */

    edge_args[0].value = (XtArgVal) Verticle;
    sw->select.top_edge = XtCreateWidget("e", edgeWidgetClass, new,
					edge_args, XtNumber(edge_args));
    *childP++ = sw->select.top_edge;

    /*
     * Create select node
     */
    node_args[2].value = (XtArgVal) sw->select.top_edge;   /* XtNfromVert */
    sw->select.node = XtCreateWidget("s", nodeWidgetClass, new,
					node_args, XtNumber(node_args));
    *childP++ = sw->select.node;

    /*
     * Get width and height of node to standardize size
     */
    width = sw->select.node->core.width;
    height = sw->select.node->core.height;

    /*
     * Set width and height of top_edge
     */
    edge_args[4].value = width;
    edge_args[5].value = height/2;
    XtSetValues(sw->select.top_edge, &(edge_args[4]), 2);
    edge_args[5].value = height;


    edge_args[0].value = (int) NoEdge;	/* XtNorientation */
    edge_args[2].value = (XtArgVal) sw->select.node;   /* fromHoriz */
    edge_args[3].value = (XtArgVal) 0;
    sw->select.dummy_edge1 = XtCreateManagedWidget("te", edgeWidgetClass, new,
					edge_args, XtNumber(edge_args));
    *childP++ = sw->select.dummy_edge1;

    edge_args[2].value = (XtArgVal) sw->select.dummy_edge1;
    edge_args[4].value /= 2;
    sw->select.dummy_edge2 = XtCreateManagedWidget("te", edgeWidgetClass, new,
					edge_args, XtNumber(edge_args));
    *childP++ = sw->select.dummy_edge2;
    node_args[2].value = (XtArgVal) sw->select.top_edge;   /* XtNfromVert */


    XtManageChildren(children, (Cardinal) (childP - children));

}



Widget XtSGetSelectWidget(w)
Widget w;
{
    SelectWidget sw = (SelectWidget) w;

    if (strcmp(XtClass(sw)->core_class.class_name, "Select"))  {
	XtErrorMsg("XtSelectGetJPWidget() called with illegal widget\n");
	}

    return((Widget) sw->select.node);
}
