#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>
#include "Node.h"
#include "Edge.h"
#include "SpoolP.h"
#include <stdio.h>

#define offset(field) XtOffset(SpoolWidget, field)


#undef offset


static void Initialize();

#define SuperClass   ((WidgetClass) &formClassRec)

SpoolClassRec spoolClassRec = {
  { /* core fields */
    /* superclass		*/	(WidgetClass) SuperClass,
    /* class_name		*/	"Spool",
    /* widget_size		*/	sizeof(SpoolRec),
    /* class_initialize		*/	NULL,
    /* class_part_initialize	*/	NULL,
    /* class_inited		*/	FALSE,
    /* initialize		*/	Initialize,
    /* initialize_hook		*/	NULL,
    /* realize			*/	XtInheritRealize,
    /* actions			*/	NULL,
    /* num_actions		*/	0,
    /* resources		*/	NULL,
    /* num_resources		*/	0,
    /* xrm_class		*/	NULLQUARK,
    /* compress_motion		*/	TRUE,
    /* compress_exposure	*/	TRUE,
    /* compress_enterleave	*/	TRUE,
    /* visible_interest		*/	FALSE,
    /* destroy			*/	NULL,
    /* resize			*/	XtInheritResize,
    /* expose			*/	XtInheritExpose,
    /* set_values		*/	NULL,
    /* set_values_hook		*/	NULL,
    /* set_values_almost	*/	XtInheritSetValuesAlmost,
    /* get_values_hook		*/	NULL,
    /* accept_focus		*/	NULL,
    /* version			*/	XtVersion,
    /* callback_private		*/	NULL,
    /* tm_table			*/	NULL,
    /* query_geometry		*/	XtInheritQueryGeometry,
    /* display_accelerator	*/	XtInheritDisplayAccelerator,
    /* extension		*/	NULL
  },
  {
    /* composite Class fields initialization */
    /* geometry_manager		*/	XtInheritGeometryManager,
    /* change_managed		*/	XtInheritChangeManaged,
    /* insert_child		*/	XtInheritInsertChild,
    /* delete_child		*/	XtInheritDeleteChild,
    /* extension		*/	NULL
  },
  { 
    /* constraint Class fields initialization */
    /* subresources		*/	NULL,
    /* subresource_count	*/	0,
    /* constraint_size		*/	sizeof(SpoolConstraintsRec),
    /* initialize		*/	NULL,
    /* destroy			*/ 	NULL,
    /* set_values		*/	NULL,
    /* extension		*/	NULL
  },
  {
    /* form Class fields initialization */
    /* layout */ 			XtInheritLayout
  },
  { /* SpoolClass fields initialization */
    /* empty			*/	0
  }
};

WidgetClass spoolWidgetClass = (WidgetClass)&spoolClassRec;


static void Initialize(request, new)
Widget request;
Widget new;
{
    Arg arg;
    SpoolWidget jpw = (SpoolWidget) new;
    static Arg node_args[] = {
	{ XtNnodeType, (XtArgVal) Spool },
	{ XtNhorizDistance, (XtArgVal) 10 },
	{ XtNvertDistance, (XtArgVal) 0},
	};
    static Arg edge_args[] = {
	{ XtNorientation, (XtArgVal) Verticle },
	{ XtNborderWidth, (XtArgVal) 0 },
	{ XtNfromHoriz, (XtArgVal) NULL },
	{ XtNhorizDistance, (XtArgVal) 10 },
	{ XtNwidth, (XtArgVal) 0 },
	{ XtNheight, (XtArgVal) 0 },
	{ XtNvertDistance, (XtArgVal) 0 },
	};
    static int width, height;

    Widget children[4], *childP = children;

    jpw->spool.node = XtCreateWidget("j-b", nodeWidgetClass, new,
					node_args, XtNumber(node_args));
    *childP++ = jpw->spool.node;

    width = jpw->spool.node->core.width;
    height = jpw->spool.node->core.height;
    edge_args[4].value = width;
    edge_args[5].value = height;

    edge_args[0].value = (int) NoEdge;	/* XtNorientation */
    edge_args[2].value = (XtArgVal) jpw->spool.node;   /* fromHoriz */
    edge_args[3].value = (XtArgVal) 0;
    jpw->spool.dummy_edge1 = XtCreateWidget("te", edgeWidgetClass, new,
					edge_args, XtNumber(edge_args));
    *childP++ = jpw->spool.dummy_edge1;

    edge_args[2].value = (XtArgVal) jpw->spool.dummy_edge1;
    edge_args[4].value /= 2;
    jpw->spool.dummy_edge2 = XtCreateWidget("te", edgeWidgetClass, new,
					edge_args, XtNumber(edge_args));
    *childP++ = jpw->spool.dummy_edge2;

    XtManageChildren(children, (Cardinal) (childP - children));

    printf("Spool::done initalization\n");
}



Widget XtSGetSpoolWidget(w)
Widget w;
{
    SpoolWidget jpw = (SpoolWidget) w;

    if (strcmp(XtClass(jpw)->core_class.class_name, "Spool"))  {
	XtErrorMsg("XtSpoolGetJPWidget() called with illegal widget\n");
	}

    return((Widget) jpw->spool.node);
}
