#ifndef _SpoolP_h
#define _SpoolP_h

#include "Spool.h"
/* include superclass private header file */
#include <X11/Xaw/FormP.h>

/* define unique representation types not found in <X11/StringDefs.h> */

#define XtRSpoolResource		"SpoolResource"

typedef struct {
    int empty;
    } SpoolClassPart;

typedef struct _SpoolClassRec {
    CoreClassPart	core_class;
    CompositeClassPart	composite_class;
    ConstraintClassPart	constraint_class;
    FormClassPart	form_class;
    SpoolClassPart	spool_class;
    } SpoolClassRec;

extern SpoolClassRec spoolClassRec;


typedef struct {
    /* resources */
    int empty;

    /* private state */
    Widget dummy_edge1;
    Widget dummy_edge2;
    Widget node;
    } SpoolPart;

typedef struct _SpoolRec {
    CorePart		core;
    CompositePart	composite;
    ConstraintPart	constraint;
    FormPart		form;
    SpoolPart	spool;
    } SpoolRec;


typedef struct { int empty; } SpoolConstraintsPart;

typedef struct _DialogConstraintsRec {
    FormConstraintsPart	form;
    SpoolConstraintsPart spool;
    } SpoolConstraintsRec, *SpoolConstraints;

#endif  _SpoolP_h
