#ifndef _Node_h
#define _Node_h

/****************************************************************
 *
 * Node widget
 *
 ****************************************************************/

/* Resources:

 Name		     Class		RepType		Default Value
 ----		     -----		-------		-------------
 background	     Background		Pixel		XtDefaultBackground
 border		     BorderColor	Pixel		XtDefaultForeground
 borderWidth	     BorderWidth	Dimension	1
 destroyCallback     Callback		Pointer		NULL
 height		     Height		Dimension	0
 mappedWhenManaged   MappedWhenManaged	Boolean		True
 sensitive	     Sensitive		Boolean		True
 width		     Width		Dimension	0
 x		     Position		Position	0
 y		     Position		Position	0
 foreground          Foreground         Pixel           XtDefaultForeground
 font                Font               XFontStruct*    XtDefaultFont
 nodeType            NodeType           NodeType        Unknown
 initiate            Processor          Int             -1
 scheduled           Processor          Int             -1
 idle                Processor          Int             -1
 done                Processor          Int             -1
 initiateColor       Foreground		Pixel		XtDefaultForeground
 scheduledColor	     Foreground         Pixel           XtDefaultForeground
 doneColor           Foreground         Pixel           XtDefaultForeground

*/

/* define any special resource names here that are not in <X11/StringDefs.h> */

#define XtNnodeType		"nodeType"
#define XtNinitiate		"initiate"
#define XtNscheduled		"scheduled"
#define XtNidle			"idle"
#define XtNdone			"done"
#define XtNinitiateColor	"initiateColor"
#define XtNscheduledColor	"scheduledColor"
#define XtNdoneColor		"doneColor"

#define XtCProcessor		"Processor"
#define XtCNodeType		"NodeType"

#define XtRNodeType		"NodeType"

#define NUM_NODETYPE	6	
typedef enum {
    Unknown,
    Spool,
    Store,
    Select,
    JoinBuild,
    JoinProbe
    } NodeType;

#define NUMPROC		32		/* Number of processors */
#define HALFPROC	16		/* Half the number of processors */

/* declare specific NodeWidget class and instance datatypes */

typedef struct _NodeClassRec*	NodeWidgetClass;
typedef struct _NodeRec*	NodeWidget;

/* declare the class constant */

extern WidgetClass nodeWidgetClass;

#endif  _Node_h
